	cpu LMM
	.module sensor.c
	.area lit(rom, con, rel)
_FactoryDefault_Param_8::
	.byte 0,0
	.dbfile ./sensor.c
	.dbsym e FactoryDefault_Param_8 _FactoryDefault_Param_8 A[2:2]c
_FactoryDefault_Param_16::
	.word 500
	.word 500
	.word 50000
	.dbsym e FactoryDefault_Param_16 _FactoryDefault_Param_16 A[6:3]i
_FactoryDefault_Param_32::
	.word 0,0
	.dbsym e FactoryDefault_Param_32 _FactoryDefault_Param_32 A[4:1]l
_FactoryDefault_Param_168::
	.byte 'P,'r,'e,'s,'s,'u,'r,'e,32,'S,'e,'n,'s,'o,'r,0
	.byte 0,0,0,0,0
	.byte 'F,'r,'a,'m,'e,32,'N,'u,'m,'b,'e,'r,0
	.byte 0,0,0,0,0,0,0,0
	.byte 'P,'r,'e,'s,'s,'u,'r,'e,0
	.word 0,0,0,0,0
	.byte 0,0
	.byte 'T,'e,'m,'p,'e,'r,'a,'t,'u,'r,'e,0
	.byte 0,0,0,0,0,0,0,0,0
	.dbsym e FactoryDefault_Param_168 _FactoryDefault_Param_168 A[84:4:21]c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_NewSample::
	.byte 0
	.dbsym e NewSample _NewSample c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
	.area text(rom, con, rel)
	.dbfile ./sensor.c
	.dbfunc e Sensor_Start _Sensor_Start fV
_Sensor_Start::
	.dbline -1
	.dbline 115
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:   sensor.c
; //  Version: 1.0, 2007/03/08
; //  Generated by Andy Kiser
; //
; //  DESCRIPTION:  sensor specific functions 
; //
; //-----------------------------------------------------------------------------
; // Originally authored by Toradex AG. This work is now available under the terms and conditions
; // of the Creative Commons License 'Attribution CC BY', details of which can be found here:
; // http://creativecommons.org/licenses/by/3.0/
; //*****************************************************************************
; //*****************************************************************************
; //#define __DEBUG__
; #include <m8c.h>        // part specific constants and macros
; #include "sensor.h"
; #include "psocgpioint.h"
; #include "pwm8.h"
; #include "feature.h"
; #include "parameters.h"
; #include "types_n_macros.h"
; //----------------------------------------
; // Sensor parameters
; // Factory Defaults are defined here (NUM_xxx are defined in "sensor.h")
; //----------------------------------------
; const BYTE FactoryDefault_Param_8   [NUM_PARAM_8] =
; {
; 	0x00,		// report mode
; 	0x00		// LED mode
; };
; 
; const WORD FactoryDefault_Param_16  [NUM_PARAM_16] = 
; {
; 	500,		// report rate [ms]
; 	500,		// sample rate [ms]
; 	50000		// sample rate [us]	(not used for this sensor)
; };
; 
; const DWORD FactoryDefault_Param_32  [NUM_PARAM_32] =
; {
; 	0x00000000	// currently no 32bit parameters
; };
; 
; const tParam_168 FactoryDefault_Param_168 [NUM_PARAM_168] =
; {
; 	"Pressure Sensor",	// user device name
; 	"Frame Number",		// user name Channel 0
; 	"Pressure",			// user name Channel 1
; 	"Temperature"		// user name Channel 2
; };
; 
; 
; //----------------------------------------
; // this module's global variables
; //----------------------------------------
; tReport Report;
; 
; //----------------------------------------
; // constant lookup-table for conversion ADC->physical value
; //----------------------------------------
; 
; 
; //----------------------------------------
; // type definitions
; //----------------------------------------
; 
; typedef enum 
; {	
; 	eIdle,
; 	eMeasuring_Temp,
; 	eMeasuring_Pressure,
; } tFSM_Measure;
; 
; //----------------------------------------
; // variables
; 
; tFSM_Measure	FSM;
; WORD			Countdown_1ms;
; 
; BOOL			NewSample = FALSE;
; 
; static	WORD C1;
; static	WORD C2_x4;
; static	WORD C3;
; //static	WORD C4_m512;
; static	signed C4_m512;
; static	WORD C5_x8;
; static	WORD C6;
; 
; static	WORD UT1;
; static	WORD C6_p50;
; static	WORD C6_p24_x11;
; static	WORD C6_p24_x3;
; 
; //static	WORD OFF, SENS;
; static	signed OFF;
; static	WORD SENS;
; 
; 
; // store original drivemodes during suspend
; BYTE			DM0_2, DM0_1, DM0_0;
; BYTE			DM2_2, DM2_1, DM2_0;
; 
; //----------------------------------------
; // function prototypes
; //
; static void MS5534_ReadCalibration(void);
; static void MS5534_Reset(void);
; 
; //-----------------------------------------------------------------------------
; // Initializes the Sensor 
; //-----------------------------------------------------------------------------
; void Sensor_Start ()
; {
	.dbline 116
; 	PWM8_Start();
	push X
	xcall _PWM8_Start
	pop X
	.dbline 117
; 	MS5534_Reset();
	xcall _MS5534_Reset
	.dbline 118
; 	MS5534_ReadCalibration();
	xcall _MS5534_ReadCalibration
	.dbline 119
; 	FSM = eIdle;
	mov REG[0xd0],>_FSM
	mov [_FSM],0
	.dbline -2
	.dbline 120
; }
L8:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Sensor_Suspend _Sensor_Suspend fV
_Sensor_Suspend::
	.dbline -1
	.dbline 126
; 
; //-----------------------------------------------------------------------------
; // Prepare Sensor for Suspend
; //-----------------------------------------------------------------------------
; void Sensor_Suspend()
; {
	.dbline 128
; 	// store original drivemodes during  suspend
; 	DM0_2 = PRT0DM2;
	mov A,REG[0x3]
	mov REG[0xd0],>_DM0_2
	mov [_DM0_2],A
	.dbline 129
; 	DM0_1 = PRT0DM1;
	or F,0x10  ; iopage = 1
	mov A,REG[0x1]
	mov REG[0xd0],>_DM0_1
	mov [_DM0_1],A
	and F,0xEF ; iopage = 0
	.dbline 130
; 	DM0_0 = PRT0DM0;
	or F,0x10  ; iopage = 1
	mov A,REG[ 0]
	mov REG[0xd0],>_DM0_0
	mov [_DM0_0],A
	and F,0xEF ; iopage = 0
	.dbline 131
; 	DM2_2 = PRT2DM2;
	mov A,REG[0xb]
	mov REG[0xd0],>_DM2_2
	mov [_DM2_2],A
	.dbline 132
; 	DM2_1 = PRT2DM1;
	or F,0x10  ; iopage = 1
	mov A,REG[0x9]
	mov REG[0xd0],>_DM2_1
	mov [_DM2_1],A
	and F,0xEF ; iopage = 0
	.dbline 133
; 	DM2_0 = PRT2DM0;
	or F,0x10  ; iopage = 1
	mov A,REG[0x8]
	mov REG[0xd0],>_DM2_0
	mov [_DM2_0],A
	and F,0xEF ; iopage = 0
	.dbline 135
; 		
; 	MS5534_Reset();
	xcall _MS5534_Reset
	.dbline 136
; 	PWM8_Stop();
	push X
	xcall _PWM8_Stop
	pop X
	.dbline 139
; 
; 	// set all I/Os to/from the sensor to High-Z Analog (=110), 
; 	PRT0DM2  = 0xFF;
	mov REG[0x3],-1
	.dbline 140
; 	PRT0DM1  = 0xFF;
	or F,0x10  ; iopage = 1
	mov REG[0x1],-1
	and F,0xEF ; iopage = 0
	.dbline 141
; 	PRT0DM0  = 0x00;
	or F,0x10  ; iopage = 1
	mov REG[ 0],0
	and F,0xEF ; iopage = 0
	.dbline 142
; 	PRT2DM2  = 0xFF;
	mov REG[0xb],-1
	.dbline 143
; 	PRT2DM1  = 0xFF;
	or F,0x10  ; iopage = 1
	mov REG[0x9],-1
	and F,0xEF ; iopage = 0
	.dbline 144
; 	PRT2DM0  = 0x00;
	or F,0x10  ; iopage = 1
	mov REG[0x8],0
	and F,0xEF ; iopage = 0
	.dbline -2
	.dbline 145
; }
L9:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Sensor_Resume _Sensor_Resume fV
_Sensor_Resume::
	.dbline -1
	.dbline 150
; //-----------------------------------------------------------------------------
; // Resume Sensor from Suspend mode
; //-----------------------------------------------------------------------------
; void Sensor_Resume()
; {
	.dbline 152
; 	// restore drivemodes for GPIOs to/from the sensor
; 	PRT2DM2 = DM2_2;
	mov REG[0xd0],>_DM2_2
	mov A,[_DM2_2]
	mov REG[0xb],A
	.dbline 153
; 	PRT2DM1 = DM2_1;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM2_1
	mov A,[_DM2_1]
	mov REG[0x9],A
	and F,0xEF ; iopage = 0
	.dbline 154
; 	PRT2DM0 = DM2_0;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM2_0
	mov A,[_DM2_0]
	mov REG[0x8],A
	and F,0xEF ; iopage = 0
	.dbline 156
; 
; 	PRT0DM2 = DM0_2;
	mov REG[0xd0],>_DM0_2
	mov A,[_DM0_2]
	mov REG[0x3],A
	.dbline 157
; 	PRT0DM1 = DM0_1;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM0_1
	mov A,[_DM0_1]
	mov REG[0x1],A
	and F,0xEF ; iopage = 0
	.dbline 158
; 	PRT0DM0 = DM0_0;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM0_0
	mov A,[_DM0_0]
	mov REG[ 0],A
	and F,0xEF ; iopage = 0
	.dbline 160
; 
; 	FSM = eIdle;
	mov REG[0xd0],>_FSM
	mov [_FSM],0
	.dbline 161
; 	PWM8_Start();
	push X
	xcall _PWM8_Start
	pop X
	.dbline 162
; 	MS5534_Reset();
	xcall _MS5534_Reset
	.dbline -2
	.dbline 163
; }
L10:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Sensor_Specific_Feature _Sensor_Specific_Feature fc
_Sensor_Specific_Feature::
	.dbline -1
	.dbline 176
; 
; //-----------------------------------------------------------------------------
; // Function that will be called when a FEATURE REPORT is received that 
; // cannot be handled with the standard functionality in feature.c
; // The feature report data is available in the "FEATURE_RPT" variable
; //
; // --> see feature.c for an example how to parse FEATURE_RPT
; //
; //	return Value: number of Parameter bytes (1-31) that are 
; //				  returned in the IN report
; //-----------------------------------------------------------------------------
; BYTE Sensor_Specific_Feature(void)
; {
	.dbline 178
; 	// currently no special feature reports are handled
; 	return 0;
	mov REG[0xd0],>__r0
	mov A,0
	.dbline -2
L11:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Sensor_Specific_Parameter _Sensor_Specific_Parameter fV
; NumberOfReturnedBytes -> X-5
_Sensor_Specific_Parameter::
	.dbline -1
	push X
	mov X,SP
	.dbline 189
; }
; 
; //-----------------------------------------------------------------------------
; // Function that will be called when a FEATURE REPORT is received that 
; // sets / gets a 8/16/32/168bit parameter in feature.c
; // The feature report data is available in the "FEATURE_RPT" variable
; //
; // --> see feature.c for an example how to parse FEATURE_RPT
; //-----------------------------------------------------------------------------
; void Sensor_Specific_Parameter(BYTE *NumberOfReturnedBytes)
; {
	.dbline -2
	.dbline 191
; 	// Oak-P does not have specific parameters
; }
L12:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l NumberOfReturnedBytes -5 pc
	.dbend
	.dbfunc e MS5534_TxRx _MS5534_TxRx fc
;             Rx -> X+1
;              i -> X+0
;           size -> X-5
;         TxData -> X-4
_MS5534_TxRx::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 201
; 
; 
; //-----------------------------------------------------------------------------
; // Transmit and Receive <size> bits to the sensor / from the sensor
; // - Data bits 0..<size-1> are transmitted, MSB first
; // - <size> must be in the range 0..8
; // return value: received bits 
; //-----------------------------------------------------------------------------
; BYTE MS5534_TxRx (BYTE TxData, BYTE size)
; {
	.dbline 203
; 	BYTE i;
; 	BYTE Rx=0;
	mov [X+1],0
	.dbline 206
; 	
; 	// shift TxData to the left end of the byte
; 	for (i=size; i<8; i++)
	mov A,[X-5]
	mov [X+0],A
	xjmp L17
L14:
	.dbline 207
	asl [X-4]
L15:
	.dbline 206
	inc [X+0]
L17:
	.dbline 206
	cmp [X+0],8
	jc L14
X0:
	xjmp L19
L18:
	.dbline 210
; 		TxData <<=1;
; 	
; 	while (size != 0)
; 	{
	.dbline 212
; 		// set MOSI output 
; 		if ( (TxData & 0x80) == 0 )
	tst [X-4],-128
	jnz L21
	.dbline 213
; 			MOSI_Data_ADDR &= ~MOSI_MASK;
	and REG[0x8],-17
	xjmp L22
L21:
	.dbline 215
; 		else
; 			MOSI_Data_ADDR |=  MOSI_MASK;
	or REG[0x8],16
L22:
	.dbline 218
; 		
; 		// wait 0.5 cycles (use time to do some processing)
; 		TxData <<= 1;
	asl [X-4]
	.dbline 219
; 		Rx <<= 1;
	asl [X+1]
	.dbline 222
; 		
; 		// generate positive clock edge
; 		SCLK_Data_ADDR |=  SCLK_MASK;
	or REG[0x8],1
	.dbline 226
; 		
; 		// wait 0.5 cycles (use time to do some processing)
; 		/*for(i=0; i<10; i++);*/
; 		size--;
	dec [X-5]
	.dbline 229
; 		
; 		// generate negative clock edge
; 		SCLK_Data_ADDR &= ~SCLK_MASK;
	and REG[0x8],-2
	.dbline 232
; 		
; 		// read Rx data bit
; 		if ( (MISO_Data_ADDR & MISO_MASK) != 0)
	tst REG[0x8],4
	jz L23
	.dbline 233
; 			Rx++;
	inc [X+1]
L23:
	.dbline 234
L19:
	.dbline 209
	cmp [X-5],0
	jnz L18
	.dbline 236
; 	}	
; 	
; 	return Rx;
	mov A,[X+1]
	mov REG[0xd0],>__r0
	.dbline -2
L13:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l Rx 1 c
	.dbsym l i 0 c
	.dbsym l size -5 c
	.dbsym l TxData -4 c
	.dbend
	.dbfunc s MS5534_Reset _MS5534_Reset fV
_MS5534_Reset:
	.dbline -1
	.dbline 243
; }
; 
; //-----------------------------------------------------------------------------
; // Send a reset sequence
; //-----------------------------------------------------------------------------
; static void MS5534_Reset(void)
; {
	.dbline 244
; 	MS5534_TxRx(0xAA, 8);
	mov A,8
	push A
	mov A,-86
	push A
	xcall _MS5534_TxRx
	add SP,-2
	mov REG[0xd0],>__r0
	.dbline 245
; 	MS5534_TxRx(0xAA, 8);
	mov A,8
	push A
	mov A,-86
	push A
	xcall _MS5534_TxRx
	mov REG[0xd0],>__r0
	.dbline 246
; 	MS5534_TxRx(0x00, 5);
	mov A,5
	push A
	mov A,0
	push A
	xcall _MS5534_TxRx
	add SP,-4
	mov REG[0xd0],>__r0
	.dbline -2
	.dbline 247
; }
L25:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc s MS5534_MeasureP_Start _MS5534_MeasureP_Start fV
_MS5534_MeasureP_Start:
	.dbline -1
	.dbline 253
; 
; //-----------------------------------------------------------------------------
; // Send Sequence to Start Pressure Measurement
; //-----------------------------------------------------------------------------
; static void MS5534_MeasureP_Start(void)
; {
	.dbline 254
; 	MS5534_TxRx(0xFF, 3);
	mov A,3
	push A
	mov A,-1
	push A
	xcall _MS5534_TxRx
	add SP,-2
	mov REG[0xd0],>__r0
	.dbline 255
; 	MS5534_TxRx(0x0A, 4);
	mov A,4
	push A
	mov A,10
	push A
	xcall _MS5534_TxRx
	mov REG[0xd0],>__r0
	.dbline 256
; 	MS5534_TxRx(0x00, 5);
	mov A,5
	push A
	mov A,0
	push A
	xcall _MS5534_TxRx
	add SP,-4
	mov REG[0xd0],>__r0
	.dbline -2
	.dbline 257
; }
L26:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc s MS5534_MeasureT_Start _MS5534_MeasureT_Start fV
_MS5534_MeasureT_Start:
	.dbline -1
	.dbline 263
; 
; //-----------------------------------------------------------------------------
; // Send Sequence to Start Temperature Measurement
; //-----------------------------------------------------------------------------
; static void MS5534_MeasureT_Start(void)
; {
	.dbline 264
; 	MS5534_TxRx(0xFF, 3);
	mov A,3
	push A
	mov A,-1
	push A
	xcall _MS5534_TxRx
	add SP,-2
	mov REG[0xd0],>__r0
	.dbline 265
; 	MS5534_TxRx(0x09, 4);
	mov A,4
	push A
	mov A,9
	push A
	xcall _MS5534_TxRx
	mov REG[0xd0],>__r0
	.dbline 266
; 	MS5534_TxRx(0x00, 5);
	mov A,5
	push A
	mov A,0
	push A
	xcall _MS5534_TxRx
	add SP,-4
	mov REG[0xd0],>__r0
	.dbline -2
	.dbline 267
; }
L27:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc s MS5534_IsMeasurementDone _MS5534_IsMeasurementDone fc
_MS5534_IsMeasurementDone:
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 272
; //-----------------------------------------------------------------------------
; // return TRUE if ADC conversion has finished and Measurement result is ready 
; //-----------------------------------------------------------------------------
; static BOOL MS5534_IsMeasurementDone(void)
; {
	.dbline 273
; 	return (MISO_Data_ADDR & MISO_MASK) == 0;
	tst REG[0x8],4
	jnz L30
	mov [X+1],1
	mov [X+0],0
	xjmp L31
L30:
	mov [X+1],0
	mov [X+0],0
L31:
	mov REG[0xd0],>__r0
	mov A,[X+1]
	.dbline -2
L28:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc s MS5534_ReadWord _MS5534_ReadWord fi
;            MSB -> X+1
;            LSB -> X+0
_MS5534_ReadWord:
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 280
; }
; 
; //-----------------------------------------------------------------------------
; // Read 16 Bit Measurement result or 16 Bit calibration word
; //-----------------------------------------------------------------------------
; static WORD MS5534_ReadWord(void)
; {
	.dbline 283
; 	BYTE LSB, MSB;
; 	
; 	MSB = MS5534_TxRx(0x00, 8);
	mov A,8
	push A
	mov A,0
	push A
	xcall _MS5534_TxRx
	add SP,-2
	mov REG[0xd0],>__r0
	mov [X+1],A
	.dbline 284
; 	LSB = MS5534_TxRx(0x00, 8);
	mov A,8
	push A
	mov A,0
	push A
	xcall _MS5534_TxRx
	mov REG[0xd0],>__r0
	mov [X+0],A
	.dbline 285
; 	MS5534_TxRx(0x00, 1);
	mov A,1
	push A
	mov A,0
	push A
	xcall _MS5534_TxRx
	add SP,-4
	mov REG[0xd0],>__r0
	.dbline 287
; 	
; 	return 256*MSB + LSB;
	mov A,[X+0]
	mov [__r1],A
	mov A,[X+1]
	mov [__r0],A
	.dbline -2
L32:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l MSB 1 c
	.dbsym l LSB 0 c
	.dbend
	.dbfunc s MS5534_ReadCalibration _MS5534_ReadCalibration fV
;            LSB -> X+14
;            MSB -> X+13
;          shift -> X+12
;           wtmp -> X+10
;            cmd -> X+9
;            Raw -> X+1
;              b -> X+0
_MS5534_ReadCalibration:
	.dbline -1
	push X
	mov X,SP
	add SP,15
	.dbline 294
; }
; 
; //-----------------------------------------------------------------------------
; // Read the calibration data from the sensor into global variables C1..C6
; //-----------------------------------------------------------------------------
; static void MS5534_ReadCalibration(void)
; {
	.dbline 301
; 	BYTE Raw[8];
; 	BYTE b, shift, cmd;
; 	BYTE MSB, LSB;
; 	WORD wtmp;
; 	
; 	// Read raw calibration data from sensor
; 	for (b=0; b<8; b++,b++)
	mov [X+0],0
	xjmp L37
L34:
	.dbline 302
; 	{
	.dbline 303
; 		if (b==0)		// produces more efficient code than a switch statement
	cmp [X+0],0
	jnz L38
	.dbline 304
; 			cmd = 0x15;
	mov [X+9],21
L38:
	.dbline 305
; 		if (b==2)
	cmp [X+0],2
	jnz L40
	.dbline 306
; 			cmd = 0x16;
	mov [X+9],22
L40:
	.dbline 307
; 		if (b==4)
	cmp [X+0],4
	jnz L42
	.dbline 308
; 			cmd = 0x19;
	mov [X+9],25
L42:
	.dbline 309
; 		if (b==6)
	cmp [X+0],6
	jnz L44
	.dbline 310
; 			cmd = 0x1A;
	mov [X+9],26
L44:
	.dbline 312
	mov A,3
	push A
	mov A,-1
	push A
	xcall _MS5534_TxRx
	mov REG[0xd0],>__r0
	.dbline 313
	mov A,6
	push A
	mov A,[X+9]
	push A
	xcall _MS5534_TxRx
	add SP,-4
	mov REG[0xd0],>__r0
	.dbline 314
	mov A,4
	push A
	mov A,0
	push A
	xcall _MS5534_TxRx
	mov REG[0xd0],>__r0
	.dbline 316
	mov A,8
	push A
	mov A,0
	push A
	xcall _MS5534_TxRx
	add SP,-4
	mov REG[0xd0],>__r0
	mov [__r0],A
	mov [__r2],3
	mov [__r3],X
	add [__r3],1
	mov A,[X+0]
	add A,[__r3]
	mov [__r3],A
	mov A,0
	adc A,[__r2]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 317
	mov A,8
	push A
	mov A,0
	push A
	xcall _MS5534_TxRx
	mov REG[0xd0],>__r0
	mov [__r0],A
	mov [__r2],3
	mov [__r3],X
	add [__r3],2
	mov A,[X+0]
	add A,[__r3]
	mov [__r3],A
	mov A,0
	adc A,[__r2]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 318
	mov A,1
	push A
	mov A,0
	push A
	xcall _MS5534_TxRx
	add SP,-4
	mov REG[0xd0],>__r0
	.dbline 320
L35:
	.dbline 301
	inc [X+0]
	inc [X+0]
L37:
	.dbline 301
	cmp [X+0],8
	jc L34
X1:
	.dbline 330
; 			
; 		MS5534_TxRx(0xFF, 3);
; 		MS5534_TxRx(cmd , 6);
; 		MS5534_TxRx(0x00, 4);
; 		
; 		Raw[b  ] = MS5534_TxRx(0x00, 8); // MSB
; 		Raw[b+1] = MS5534_TxRx(0x00, 8); // LSB
; 		MS5534_TxRx(0x00, 1);
; 
; 	}
; 		//Raw[0] = 0xb7;	//TestValues
; 		//Raw[1] = 0x5C;
; 		//Raw[2] = 0x9d;
; 		//Raw[3] = 0x19;
; 		//Raw[4] = 0x62;
; 		//Raw[5] = 0x54;
; 		//Raw[6] = 0xb8;
; 		//Raw[7] = 0x6c;
; 	// move raw calibration data into global variables C1..C6
; 	C1		= (Raw[0]*256+ Raw[1]); C1>>=1;
	mov REG[0xd0],>_C1
	mov A,[X+2]
	mov [_C1+1],A
	mov A,[X+1]
	mov [_C1],A
	.dbline 330
	and F,-5
	rrc [_C1]
	rrc [_C1+1]
	.dbline 331
; 	C2_x4	= (Raw[5]&0x3F)*256; C2_x4+=(Raw[7]&0x3F)<<2;
	mov REG[0xd0],>__r0
	mov A,[X+6]
	mov [__r1],A
	mov [__r0],0
	and [__r1],63
	and [__r0],0
	mov A,[__r1]
	mov [__r0],A
	mov A,0
	push A
	mov A,[__r0]
	mov REG[0xd0],>_C2_x4
	mov [_C2_x4],A
	pop A
	mov [_C2_x4+1],A
	.dbline 331
	mov REG[0xd0],>__r0
	mov A,[X+8]
	mov [__r1],A
	mov [__r0],0
	and [__r1],63
	and [__r0],0
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	mov A,[__r1]
	mov REG[0xd0],>_C2_x4
	add [_C2_x4+1],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	mov REG[0xd0],>_C2_x4
	adc [_C2_x4],A
	.dbline 332
; 	C3		= (Raw[6]*256+ Raw[7]); C3>>=6;
	mov REG[0xd0],>_C3
	mov A,[X+8]
	mov [_C3+1],A
	mov A,[X+7]
	mov [_C3],A
	.dbline 332
	and F,-5
	rrc [_C3]
	rrc [_C3+1]
	and F,-5
	rrc [_C3]
	rrc [_C3+1]
	and F,-5
	rrc [_C3]
	rrc [_C3+1]
	and F,-5
	rrc [_C3]
	rrc [_C3+1]
	and F,-5
	rrc [_C3]
	rrc [_C3+1]
	and F,-5
	rrc [_C3]
	rrc [_C3+1]
	.dbline 334
; 	//C4_m512	= (Raw[4]*256+ Raw[5]); C4_m512= (C4_m512>>=6) - 512;
; 	wtmp	= (Raw[4]*256+ Raw[5]);
	mov A,[X+6]
	mov [X+11],A
	mov A,[X+5]
	mov [X+10],A
	.dbline 335
; 	C4_m512= (wtmp>>=6) - 512;
	mov REG[0xd0],>__r0
	mov A,[X+11]
	mov [__r1],A
	mov A,[X+10]
	mov [__r0],A
	and F,-5
	rrc [__r0]
	rrc [__r1]
	and F,-5
	rrc [__r0]
	rrc [__r1]
	and F,-5
	rrc [__r0]
	rrc [__r1]
	and F,-5
	rrc [__r0]
	rrc [__r1]
	and F,-5
	rrc [__r0]
	rrc [__r1]
	and F,-5
	rrc [__r0]
	rrc [__r1]
	mov A,[__r1]
	mov [X+11],A
	mov A,[__r0]
	mov [X+10],A
	sub [__r1],0
	sbb [__r0],2
	mov A,[__r1]
	push A
	mov A,[__r0]
	mov REG[0xd0],>_C4_m512
	mov [_C4_m512],A
	pop A
	mov [_C4_m512+1],A
	.dbline 336
; 	C5_x8	= (Raw[2]*256+ Raw[3]) & 0xFFC0; 
	mov REG[0xd0],>__r0
	mov A,[X+4]
	mov [__r1],A
	mov A,[X+3]
	mov [__r0],A
	mov A,[__r1]
	and A,-64
	mov REG[0xd0],>_C5_x8
	mov [_C5_x8+1],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	mov REG[0xd0],>_C5_x8
	mov [_C5_x8],A
	.dbline 337
; 	C5_x8 >>= 3; 
	and F,-5
	rrc [_C5_x8]
	rrc [_C5_x8+1]
	and F,-5
	rrc [_C5_x8]
	rrc [_C5_x8+1]
	and F,-5
	rrc [_C5_x8]
	rrc [_C5_x8+1]
	.dbline 338
; 	C5_x8  += ((Raw[1]&0x01)<<5)*256;
	mov REG[0xd0],>__r0
	mov A,[X+2]
	mov [__r1],A
	mov [__r0],0
	and [__r1],1
	and [__r0],0
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	mov A,[__r1]
	mov REG[0xd0],>_C5_x8
	add [_C5_x8+1],0
	adc [_C5_x8],A
	.dbline 339
; 	C6		= (Raw[3]&0x3F);
	mov REG[0xd0],>__r0
	mov A,[X+4]
	mov [__r1],A
	mov [__r0],0
	and [__r1],63
	and [__r0],0
	mov A,[__r1]
	push A
	mov A,[__r0]
	mov REG[0xd0],>_C6
	mov [_C6],A
	pop A
	mov [_C6+1],A
	.dbline 342
; 
; 	// precalculate values that are constant for a particular sensor
; 	UT1 = C5_x8 + 20224;
	mov REG[0xd0],>_C5_x8
	mov A,[_C5_x8+1]
	add A,0
	mov REG[0xd0],>_UT1
	mov [_UT1+1],A
	mov REG[0xd0],>_C5_x8
	mov A,[_C5_x8]
	adc A,79
	mov REG[0xd0],>_UT1
	mov [_UT1],A
	.dbline 343
; 	C6_p50 = C6 + 50;
	mov REG[0xd0],>_C6
	mov A,[_C6+1]
	add A,50
	mov REG[0xd0],>_C6_p50
	mov [_C6_p50+1],A
	mov REG[0xd0],>_C6
	mov A,[_C6]
	adc A,0
	mov REG[0xd0],>_C6_p50
	mov [_C6_p50],A
	.dbline 344
; 	C6_p24_x11 = (C6 + 24)*11;
	mov REG[0xd0],>_C6
	mov A,[_C6+1]
	add A,24
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov REG[0xd0],>_C6
	mov A,[_C6]
	adc A,0
	mov REG[0xd0],>__r0
	push A
	mov A,[__r1]
	push A
	mov A,0
	push A
	mov A,11
	push A
	xcall __mul16
	add SP,-4
	mov A,[__rX]
	mov REG[0xd0],>_C6_p24_x11
	mov [_C6_p24_x11+1],A
	mov REG[0xd0],>__r0
	mov A,[__rY]
	mov REG[0xd0],>_C6_p24_x11
	mov [_C6_p24_x11],A
	.dbline 345
; 	C6_p24_x3 = (C6 + 24)*3;
	mov REG[0xd0],>_C6
	mov A,[_C6+1]
	add A,24
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov REG[0xd0],>_C6
	mov A,[_C6]
	adc A,0
	mov REG[0xd0],>__r0
	push A
	mov A,[__r1]
	push A
	mov A,0
	push A
	mov A,3
	push A
	xcall __mul16
	add SP,-4
	mov A,[__rX]
	mov REG[0xd0],>_C6_p24_x3
	mov [_C6_p24_x3+1],A
	mov REG[0xd0],>__r0
	mov A,[__rY]
	mov REG[0xd0],>_C6_p24_x3
	mov [_C6_p24_x3],A
	.dbline -2
	.dbline 346
; }
L33:
	add SP,-15
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l LSB 14 c
	.dbsym l MSB 13 c
	.dbsym l shift 12 c
	.dbsym l wtmp 10 i
	.dbsym l cmd 9 c
	.dbsym l Raw 1 A[8:8]c
	.dbsym l b 0 c
	.dbend
	.dbfunc s MS5534_Compute _MS5534_Compute fV
;              X -> X+18
;             sq -> X+14
;              P -> X+12
;             dT -> X+10
;             P2 -> X+8
;           TEMP -> X+6
;             T2 -> X+4
;           ltmp -> X+0
;           Temp -> X-11
;       Pressure -> X-9
;             D2 -> X-7
;             D1 -> X-5
_MS5534_Compute:
	.dbline -1
	push X
	mov X,SP
	add SP,20
	.dbline 358
; 
; //-----------------------------------------------------------------------------
; // Turn the raw ADC values into real Pressure and temperature 
; // (resolution: 0.1C / 10Pa)
; //
; // side effects:
; // changes global variables
; //  - OFF
; //  - SENS
; //-----------------------------------------------------------------------------
; static void MS5534_Compute(WORD D1, WORD D2, WORD *Pressure, WORD *Temp)
; {
	.dbline 370
; //	WORD TEMP, P, T2, P2;
; //	WORD dT, X;
; 	signed TEMP, P, T2, P2; 
; 	signed dT, X;	
; //	unsigned long ltmp, sq;
; 	signed long ltmp, sq; 
; 
; 		//D1 = 16460; //TestValues
; 		//D2 = 20000;
; 	
; 	// --- basic equations
; 	dT = D2 - UT1;
	mov REG[0xd0],>_UT1
	mov A,[X-6]
	sub A,[_UT1+1]
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov A,[X-7]
	mov REG[0xd0],>_UT1
	sbb A,[_UT1]
	mov REG[0xd0],>__r0
	mov [__r0],A
	mov A,[__r1]
	mov [X+11],A
	mov A,[__r0]
	mov [X+10],A
	.dbline 374
; 	
; //	ltmp = (unsigned long)C6_p50 * dT;
; //	TEMP = (WORD)((ltmp/256) >>2) + 200; 
; 	ltmp = (unsigned long)C6_p50 * dT; 
	mov A,[X+11]
	mov [__r3],A
	mov A,[X+10]
	mov [__r2],A
	tst [__r2],-128
	jz X2
	mov [__r1],-1
	mov [__r0],-1
	jmp X3
X2:
	mov REG[0xd0],>__r0
	mov [__r1],0
	mov [__r0],0
X3:
	mov REG[0xd0],>_C6_p50
	mov A,[_C6_p50+1]
	mov REG[0xd0],>__r0
	mov [__r7],A
	mov REG[0xd0],>_C6_p50
	mov A,[_C6_p50]
	mov REG[0xd0],>__r0
	mov [__r6],A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,0
	push A
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [X+0],A
	mov A,[__r1]
	mov [X+1],A
	mov A,[__r2]
	mov [X+2],A
	mov A,[__r3]
	mov [X+3],A
	.dbline 375
; 	TEMP = (signed)((ltmp/256) >>2) + 200; 
	mov A,0
	push A
	push A
	mov A,1
	push A
	mov A,0
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __divmod_32X32_32
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-4
	mov A,2
X4:
	mov REG[0xd0],>__r0
	asr [__r0]
	rrc [__r1]
	rrc [__r2]
	rrc [__r3]
	dec A
	jnz X4
	mov A,[__r3]
	mov [__r1],A
	mov A,[__r2]
	mov [__r0],A
	mov A,[__r1]
	add A,-56
	mov [X+7],A
	mov A,[__r0]
	adc A,0
	mov [X+6],A
	.dbline 379
; 	
; //	ltmp = (unsigned long)C4_m512 * dT;
; //	OFF =  (WORD)((ltmp/256)>>4) + C2_x4;
; 	ltmp = (signed long)C4_m512 * dT;
	mov A,[X+11]
	mov [__r3],A
	mov A,[X+10]
	mov [__r2],A
	tst [__r2],-128
	jz X5
	mov [__r1],-1
	mov [__r0],-1
	jmp X6
X5:
	mov REG[0xd0],>__r0
	mov [__r1],0
	mov [__r0],0
X6:
	mov REG[0xd0],>_C4_m512
	mov A,[_C4_m512+1]
	mov REG[0xd0],>__r0
	mov [__r7],A
	mov REG[0xd0],>_C4_m512
	mov A,[_C4_m512]
	mov REG[0xd0],>__r0
	mov [__r6],A
	tst [__r6],-128
	jz X7
	mov [__r5],-1
	mov [__r4],-1
	jmp X8
X7:
	mov REG[0xd0],>__r0
	mov [__r5],0
	mov [__r4],0
X8:
	mov REG[0xd0],>__r0
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	.dbline 380
; 	OFF =  (signed)((ltmp/256)>>4) + C2_x4;
	mov A,0
	push A
	push A
	mov A,1
	push A
	mov A,0
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __divmod_32X32_32
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-4
	mov A,4
X9:
	mov REG[0xd0],>__r0
	asr [__r0]
	rrc [__r1]
	rrc [__r2]
	rrc [__r3]
	dec A
	jnz X9
	mov A,[__r3]
	mov [__r1],A
	mov A,[__r2]
	mov [__r0],A
	mov REG[0xd0],>_C2_x4
	mov A,[_C2_x4+1]
	mov REG[0xd0],>__r0
	add [__r1],A
	mov REG[0xd0],>_C2_x4
	mov A,[_C2_x4]
	mov REG[0xd0],>__r0
	adc [__r0],A
	mov A,[__r1]
	push A
	mov A,[__r0]
	mov REG[0xd0],>_OFF
	mov [_OFF],A
	pop A
	mov [_OFF+1],A
	.dbline 384
; 	
; //	ltmp = (unsigned long)C3 * dT;
; //	SENS = (WORD)((ltmp/256)>>2) + C1 + 24576;
; 	ltmp = (unsigned long)C3 * dT;
	mov REG[0xd0],>__r0
	mov A,[X+11]
	mov [__r3],A
	mov A,[X+10]
	mov [__r2],A
	tst [__r2],-128
	jz X10
	mov [__r1],-1
	mov [__r0],-1
	jmp X11
X10:
	mov REG[0xd0],>__r0
	mov [__r1],0
	mov [__r0],0
X11:
	mov REG[0xd0],>_C3
	mov A,[_C3+1]
	mov REG[0xd0],>__r0
	mov [__r7],A
	mov REG[0xd0],>_C3
	mov A,[_C3]
	mov REG[0xd0],>__r0
	mov [__r6],A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,0
	push A
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [X+0],A
	mov A,[__r1]
	mov [X+1],A
	mov A,[__r2]
	mov [X+2],A
	mov A,[__r3]
	mov [X+3],A
	.dbline 385
; 	SENS = (WORD)((ltmp/256)>>2) + C1 + 24576;
	mov A,0
	push A
	push A
	mov A,1
	push A
	mov A,0
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __divmod_32X32_32
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-4
	mov A,2
X12:
	mov REG[0xd0],>__r0
	asr [__r0]
	rrc [__r1]
	rrc [__r2]
	rrc [__r3]
	dec A
	jnz X12
	mov A,[__r3]
	mov [__r1],A
	mov A,[__r2]
	mov [__r0],A
	mov REG[0xd0],>_C1
	mov A,[_C1+1]
	mov REG[0xd0],>__r0
	add [__r1],A
	mov REG[0xd0],>_C1
	mov A,[_C1]
	mov REG[0xd0],>__r0
	adc [__r0],A
	mov A,[__r1]
	add A,0
	mov REG[0xd0],>_SENS
	mov [_SENS+1],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	adc A,96
	mov REG[0xd0],>_SENS
	mov [_SENS],A
	.dbline 389
; 	
; //	ltmp = (unsigned long)(D1-7168) * SENS;
; //	X 	 = (WORD)((ltmp/256)>>6) - OFF;
; 	ltmp = (unsigned long)(D1-7168) * SENS;
	mov A,[_SENS+1]
	mov REG[0xd0],>__r0
	mov [__r3],A
	mov REG[0xd0],>_SENS
	mov A,[_SENS]
	mov REG[0xd0],>__r0
	mov [__r2],A
	mov A,[X-4]
	sub A,0
	mov [__r5],A
	mov A,[X-5]
	sbb A,28
	mov [__r4],A
	mov A,[__r5]
	mov [__r7],A
	mov A,[__r4]
	mov [__r6],A
	mov A,0
	push A
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,0
	push A
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [X+0],A
	mov A,[__r1]
	mov [X+1],A
	mov A,[__r2]
	mov [X+2],A
	mov A,[__r3]
	mov [X+3],A
	.dbline 390
; 	X 	 = (signed)((ltmp/256)>>6) - OFF;
	mov A,0
	push A
	push A
	mov A,1
	push A
	mov A,0
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __divmod_32X32_32
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-4
	mov A,6
X13:
	mov REG[0xd0],>__r0
	asr [__r0]
	rrc [__r1]
	rrc [__r2]
	rrc [__r3]
	dec A
	jnz X13
	mov A,[__r3]
	mov [__r1],A
	mov A,[__r2]
	mov [__r0],A
	mov A,[__r1]
	mov REG[0xd0],>_OFF
	sub A,[_OFF+1]
	mov [X+19],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	mov REG[0xd0],>_OFF
	sbb A,[_OFF]
	mov [X+18],A
	.dbline 394
; 	
; //	ltmp = (unsigned long)10 * X;
; //	P	 = (WORD)(ltmp >>5) + 2500;
; 	ltmp = (signed long)10 * X;
	mov REG[0xd0],>__r0
	mov A,[X+19]
	mov [__r3],A
	mov A,[X+18]
	mov [__r2],A
	tst [__r2],-128
	jz X14
	mov [__r1],-1
	mov [__r0],-1
	jmp X15
X14:
	mov REG[0xd0],>__r0
	mov [__r1],0
	mov [__r0],0
X15:
	mov REG[0xd0],>__r0
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,0
	push A
	push A
	push A
	mov A,10
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	.dbline 395
; 	P	 = (signed)(ltmp >>5) + 2500;
	mov A,[X+0]
	mov [__r0],A
	mov A,[X+1]
	mov [__r1],A
	mov A,[X+2]
	mov [__r2],A
	mov A,[X+3]
	mov [__r3],A
	mov A,5
X16:
	mov REG[0xd0],>__r0
	asr [__r0]
	rrc [__r1]
	rrc [__r2]
	rrc [__r3]
	dec A
	jnz X16
	mov A,[__r3]
	mov [__r1],A
	mov A,[__r2]
	mov [__r0],A
	mov A,[__r1]
	add A,-60
	mov [X+13],A
	mov A,[__r0]
	adc A,9
	mov [X+12],A
	.dbline 398
; 	
; 	// --- second order temperature compensation
; 	if (TEMP < 200)
	mov A,[X+7]
	sub A,-56
	mov A,[X+6]
	xor A,-128
	sbb A,(0 ^ 0x80)
	jnc L59
X17:
	.dbline 399
; 	{
	.dbline 400
; 		sq=200-TEMP;
	mov REG[0xd0],>__r0
	mov A,-56
	sub A,[X+7]
	mov [__r1],A
	mov A,0
	sbb A,[X+6]
	mov [__r0],A
	mov A,[__r1]
	mov [X+17],A
	mov A,[__r0]
	mov [X+16],A
	tst [X+16],-128
	jz X18
	mov [X+15],-1
	mov [X+14],-1
	jmp X19
X18:
	mov [X+15],0
	mov [X+14],0
X19:
	.dbline 401
; 		ltmp = C6_p24_x11 * sq * sq;
	mov REG[0xd0],>_C6_p24_x11
	mov A,[_C6_p24_x11+1]
	mov REG[0xd0],>__r0
	mov [__r3],A
	mov REG[0xd0],>_C6_p24_x11
	mov A,[_C6_p24_x11]
	mov REG[0xd0],>__r0
	mov [__r2],A
	mov A,[X+14]
	push A
	mov A,[X+15]
	push A
	mov A,[X+16]
	push A
	mov A,[X+17]
	push A
	mov A,0
	push A
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	mov A,[X+14]
	push A
	mov A,[X+15]
	push A
	mov A,[X+16]
	push A
	mov A,[X+17]
	push A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	.dbline 402
; 		T2 = (ltmp/65536)>>4;
	mov A,0
	push A
	mov A,1
	push A
	mov A,0
	push A
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __divmod_32X32_32
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-4
	mov A,4
X20:
	mov REG[0xd0],>__r0
	asr [__r0]
	rrc [__r1]
	rrc [__r2]
	rrc [__r3]
	dec A
	jnz X20
	mov A,[__r3]
	mov [__r1],A
	mov A,[__r2]
	mov [__r0],A
	mov A,[__r1]
	mov [X+5],A
	mov A,[__r0]
	mov [X+4],A
	.dbline 404
; 		
; 		ltmp = 3 * (signed long)T2 * (P-3500);
	mov A,[X+13]
	sub A,-84
	mov [__r1],A
	mov A,[X+12]
	sbb A,13
	mov [__r0],A
	mov A,[__r1]
	mov [__r3],A
	mov A,[__r0]
	mov [__r2],A
	tst [__r2],-128
	jz X21
	mov [__r1],-1
	mov [__r0],-1
	jmp X22
X21:
	mov REG[0xd0],>__r0
	mov [__r1],0
	mov [__r0],0
X22:
	mov REG[0xd0],>__r0
	mov A,[X+5]
	mov [__r7],A
	mov A,[X+4]
	mov [__r6],A
	tst [__r6],-128
	jz X23
	mov [__r5],-1
	mov [__r4],-1
	jmp X24
X23:
	mov REG[0xd0],>__r0
	mov [__r5],0
	mov [__r4],0
X24:
	mov REG[0xd0],>__r0
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	mov A,0
	push A
	push A
	push A
	mov A,3
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [__r7],A
	pop A
	mov [__r6],A
	pop A
	mov [__r5],A
	pop A
	mov [__r4],A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	.dbline 405
; 		P2 = (ltmp/256)>>6;
	mov A,0
	push A
	push A
	mov A,1
	push A
	mov A,0
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __divmod_32X32_32
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-4
	mov A,6
X25:
	mov REG[0xd0],>__r0
	asr [__r0]
	rrc [__r1]
	rrc [__r2]
	rrc [__r3]
	dec A
	jnz X25
	mov A,[__r3]
	mov [__r1],A
	mov A,[__r2]
	mov [__r0],A
	mov A,[__r1]
	mov [X+9],A
	mov A,[__r0]
	mov [X+8],A
	.dbline 406
; 	}
	xjmp L60
L59:
	.dbline 407
; 	else if (TEMP > 450)	
	mov A,-62
	sub A,[X+7]
	mov A,[X+6]
	xor A,-128
	mov REG[0xd0],>__r0
	mov [__rX],A
	mov A,(1 ^ 0x80)
	sbb A,[__rX]
	jnc L61
X26:
	.dbline 408
; 	{
	.dbline 409
; 		sq=TEMP-450;
	mov REG[0xd0],>__r0
	mov A,[X+7]
	sub A,-62
	mov [__r1],A
	mov A,[X+6]
	sbb A,1
	mov [__r0],A
	mov A,[__r1]
	mov [X+17],A
	mov A,[__r0]
	mov [X+16],A
	tst [X+16],-128
	jz X27
	mov [X+15],-1
	mov [X+14],-1
	jmp X28
X27:
	mov [X+15],0
	mov [X+14],0
X28:
	.dbline 410
; 		ltmp = C6_p24_x3 * sq * sq;
	mov REG[0xd0],>_C6_p24_x3
	mov A,[_C6_p24_x3+1]
	mov REG[0xd0],>__r0
	mov [__r3],A
	mov REG[0xd0],>_C6_p24_x3
	mov A,[_C6_p24_x3]
	mov REG[0xd0],>__r0
	mov [__r2],A
	mov A,[X+14]
	push A
	mov A,[X+15]
	push A
	mov A,[X+16]
	push A
	mov A,[X+17]
	push A
	mov A,0
	push A
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	mov A,[X+14]
	push A
	mov A,[X+15]
	push A
	mov A,[X+16]
	push A
	mov A,[X+17]
	push A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	.dbline 411
; 		T2 = (ltmp/65536)>>4;
	mov A,0
	push A
	mov A,1
	push A
	mov A,0
	push A
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __divmod_32X32_32
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-4
	mov A,4
X29:
	mov REG[0xd0],>__r0
	asr [__r0]
	rrc [__r1]
	rrc [__r2]
	rrc [__r3]
	dec A
	jnz X29
	mov A,[__r3]
	mov [__r1],A
	mov A,[__r2]
	mov [__r0],A
	mov A,[__r1]
	mov [X+5],A
	mov A,[__r0]
	mov [X+4],A
	.dbline 413
; 		
; 		ltmp = (signed long)T2 * (P-10000);
	mov A,[X+13]
	sub A,16
	mov [__r1],A
	mov A,[X+12]
	sbb A,39
	mov [__r0],A
	mov A,[__r1]
	mov [__r3],A
	mov A,[__r0]
	mov [__r2],A
	tst [__r2],-128
	jz X30
	mov [__r1],-1
	mov [__r0],-1
	jmp X31
X30:
	mov REG[0xd0],>__r0
	mov [__r1],0
	mov [__r0],0
X31:
	mov REG[0xd0],>__r0
	mov A,[X+5]
	mov [__r7],A
	mov A,[X+4]
	mov [__r6],A
	tst [__r6],-128
	jz X32
	mov [__r5],-1
	mov [__r4],-1
	jmp X33
X32:
	mov REG[0xd0],>__r0
	mov [__r5],0
	mov [__r4],0
X33:
	mov REG[0xd0],>__r0
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	.dbline 414
; 		P2 = (ltmp/256)>>5;
	mov A,0
	push A
	push A
	mov A,1
	push A
	mov A,0
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __divmod_32X32_32
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-4
	mov A,5
X34:
	mov REG[0xd0],>__r0
	asr [__r0]
	rrc [__r1]
	rrc [__r2]
	rrc [__r3]
	dec A
	jnz X34
	mov A,[__r3]
	mov [__r1],A
	mov A,[__r2]
	mov [__r0],A
	mov A,[__r1]
	mov [X+9],A
	mov A,[__r0]
	mov [X+8],A
	.dbline 415
; 	}
	xjmp L62
L61:
	.dbline 417
; 	else
; 	{
	.dbline 418
; 		T2 = 0;
	mov [X+5],0
	mov [X+4],0
	.dbline 419
; 		P2 = 0;
	mov [X+9],0
	mov [X+8],0
	.dbline 420
; 	}
L62:
L60:
	.dbline 424
; 	
; 	
; 	// return results
; 	T2 = TEMP-T2;	
	mov A,[X+7]
	sub A,[X+5]
	mov [X+5],A
	mov A,[X+6]
	sbb A,[X+4]
	mov [X+4],A
	.dbline 425
; 	P2 = P- P2;	
	mov A,[X+13]
	sub A,[X+9]
	mov [X+9],A
	mov A,[X+12]
	sbb A,[X+8]
	mov [X+8],A
	.dbline 426
; 	*Temp = T2 + 2731;	// +273.1 for conversion degC->K
	mov REG[0xd0],>__r0
	mov A,[X+5]
	add A,-85
	mov [__r1],A
	mov A,[X+4]
	adc A,10
	mov [__r0],A
	mov A,[X-10]
	mov [__r3],A
	mov A,[X-11]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	mov A,[__r1]
	mvi [__r3],A
	.dbline 427
; 	*Pressure = P2;
	mov A,[X-8]
	mov [__r1],A
	mov A,[X-9]
	mov REG[0xd5],A
	mov A,[X+8]
	mvi [__r1],A
	mov A,[X+9]
	mvi [__r1],A
	.dbline -2
	.dbline 428
; }
L58:
	add SP,-20
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l X 18 I
	.dbsym l sq 14 L
	.dbsym l P 12 I
	.dbsym l dT 10 I
	.dbsym l P2 8 I
	.dbsym l TEMP 6 I
	.dbsym l T2 4 I
	.dbsym l ltmp 0 L
	.dbsym l Temp -11 pi
	.dbsym l Pressure -9 pi
	.dbsym l D2 -7 i
	.dbsym l D1 -5 i
	.dbend
	.area data(ram, con, rel)
	.dbfile ./sensor.c
L64:
	.byte 0,0
	.area data(ram, con, rel)
	.dbfile ./sensor.c
L65:
	.byte 0,0
	.area text(rom, con, rel)
	.dbfile ./sensor.c
	.dbfunc e Sensor_FSM_Measure _Sensor_FSM_Measure fV
	.dbsym s Temp_Raw L65 i
	.dbsym s Pressure_Raw L64 i
;           Temp -> X+2
;       Pressure -> X+0
_Sensor_FSM_Measure::
	.dbline -1
	push X
	mov X,SP
	add SP,6
	.dbline 440
; 
; //-----------------------------------------------------------------------------
; // void Sensor_FSM_Measure(void)
; //
; //	finite state machine to control the measurement process for 
; //  the sensor
; //
; //  IMPORTANT: 	call this routine once every millisecond. Otherwise the timing
; //				parameters cannot be met.
; //-----------------------------------------------------------------------------
; void Sensor_FSM_Measure(void) 
; {
	.dbline 447
; 	WORD		Pressure;
; 	WORD		Temp;
; 	static WORD Pressure_Raw; // Pressure ADC value
; 	static WORD Temp_Raw; // Temperature ADC value
; 
; 	// decrement millisecond counter
; 	if (Countdown_1ms != 0)
	mov REG[0xd0],>_Countdown_1ms
	cmp [_Countdown_1ms],0
	jnz X36
	cmp [_Countdown_1ms+1],0
	jz L66
X36:
	.dbline 448
; 		Countdown_1ms--;
	mov REG[0xd0],>_Countdown_1ms
	dec [_Countdown_1ms+1]
	sbb [_Countdown_1ms],0
L66:
	.dbline 451
; 
; 	// process actual state machine
; 	switch (FSM)
	mov REG[0xd0],>_FSM
	mov A,[_FSM]
	mov [X+5],A
	mov [X+4],0
	cmp [X+4],0
	jnz X37
	cmp [X+5],0
	jz L71
X37:
	cmp [X+4],0
	jnz X38
	cmp [X+5],1
	jz L74
X38:
	cmp [X+4],0
	jnz X39
	cmp [X+5],2
	jz L77
X39:
	xjmp L68
X35:
	.dbline 452
; 	{
L71:
	.dbline 454
; 		case eIdle: 
; 			if (Countdown_1ms == 0)
	mov REG[0xd0],>_Countdown_1ms
	cmp [_Countdown_1ms],0
	jnz L69
	cmp [_Countdown_1ms+1],0
	jnz L69
X40:
	.dbline 455
; 			{
	.dbline 456
; 				Get_Param_16(PAR16_SAMPLERATE_MS, VOLATILE, &Countdown_1ms);;
	mov A,>_Countdown_1ms
	push A
	mov A,<_Countdown_1ms
	push A
	mov A,0
	push A
	mov A,1
	push A
	xcall _Get_Param_16
	add SP,-4
	.dbline 456
	.dbline 459
; 			
; 				// start temperature measurement
; 				MS5534_MeasureT_Start();
	xcall _MS5534_MeasureT_Start
	.dbline 461
; 		
; 				FSM = eMeasuring_Temp;
	mov REG[0xd0],>_FSM
	mov [_FSM],1
	.dbline 462
; 			}
	.dbline 463
; 			break;			
	xjmp L69
L74:
	.dbline 466
; 			
; 		case eMeasuring_Temp:
; 			if (MS5534_IsMeasurementDone())
	xcall _MS5534_IsMeasurementDone
	mov REG[0xd0],>__r0
	cmp A,0
	jz L69
	.dbline 467
; 			{
	.dbline 468
; 				Temp_Raw = MS5534_ReadWord();	// read temperature ADC
	xcall _MS5534_ReadWord
	mov REG[0xd0],>__r0
	mov A,[__r1]
	push A
	mov A,[__r0]
	mov REG[0xd0],>L65
	mov [L65],A
	pop A
	mov [L65+1],A
	.dbline 471
; 				
; 				// start pressure measurement
; 				MS5534_MeasureP_Start();
	xcall _MS5534_MeasureP_Start
	.dbline 472
; 				FSM = eMeasuring_Pressure;
	mov REG[0xd0],>_FSM
	mov [_FSM],2
	.dbline 473
; 			}
	.dbline 474
; 			break;			
	xjmp L69
L77:
	.dbline 477
; 		
; 		case eMeasuring_Pressure:
; 			if (MS5534_IsMeasurementDone())
	xcall _MS5534_IsMeasurementDone
	mov REG[0xd0],>__r0
	cmp A,0
	jz L69
	.dbline 478
; 			{
	.dbline 479
; 				Pressure_Raw = MS5534_ReadWord();	// read temperature ADC
	xcall _MS5534_ReadWord
	mov REG[0xd0],>__r0
	mov A,[__r1]
	push A
	mov A,[__r0]
	mov REG[0xd0],>L64
	mov [L64],A
	pop A
	mov [L64+1],A
	.dbline 482
; 				
; 				// calculate actual Pressure and Temperature (calibrated)
; 				MS5534_Compute(Pressure_Raw, Temp_Raw, &Pressure, &Temp);
	mov REG[0xd0],>__r0
	mov [__r1],X
	add [__r1],2
	mov A,3
	push A
	mov A,[__r1]
	push A
	mov A,3
	push A
	push X
	mov REG[0xd0],>L65
	mov A,[L65]
	push A
	mov A,[L65+1]
	push A
	mov REG[0xd0],>L64
	mov A,[L64]
	push A
	mov A,[L64+1]
	push A
	xcall _MS5534_Compute
	add SP,-8
	.dbline 485
; 
; 				// fill measured data into IN REPORT
; 				Report.Ch1_LSB = Pressure & 0xFF;
	mov A,[X+1]
	mov REG[0xd0],>_Report
	mov [_Report+2],A
	.dbline 486
; 				Report.Ch1_MSB = Pressure / 0x100;
	mov A,[X+0]
	mov [_Report+3],A
	.dbline 487
; 				Report.Ch2_LSB = Temp & 0xFF;
	mov A,[X+3]
	mov [_Report+4],A
	.dbline 488
; 				Report.Ch2_MSB = Temp / 0x100;
	mov A,[X+2]
	mov [_Report+5],A
	.dbline 490
; 
; 				NewSample=TRUE;
	mov REG[0xd0],>_NewSample
	mov [_NewSample],1
	.dbline 493
; 				
; 				// Reset the sensor
; 				MS5534_Reset();
	xcall _MS5534_Reset
	.dbline 494
; 				FSM = eIdle;
	mov REG[0xd0],>_FSM
	mov [_FSM],0
	.dbline 495
; 			}
	.dbline 496
; 			break;			
L68:
L69:
	.dbline -2
	.dbline 498
; 	}
; }
L63:
	add SP,-6
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l Temp 2 i
	.dbsym l Pressure 0 i
	.dbend
	.dbfunc e Sensor_Debug _Sensor_Debug fV
_Sensor_Debug::
	.dbline -1
	.dbline 503
; 
; 
; //-----------------------------------------------------------------------------
; void Sensor_Debug(void)
; {
	.dbline -2
	.dbline 505
; /* currently no debug function */
; }
L84:
	.dbline 0 ; func end
	ret
	.dbend
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM2_0::
	.byte 0
	.dbsym e DM2_0 _DM2_0 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM2_1::
	.byte 0
	.dbsym e DM2_1 _DM2_1 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM2_2::
	.byte 0
	.dbsym e DM2_2 _DM2_2 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM0_0::
	.byte 0
	.dbsym e DM0_0 _DM0_0 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM0_1::
	.byte 0
	.dbsym e DM0_1 _DM0_1 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM0_2::
	.byte 0
	.dbsym e DM0_2 _DM0_2 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_SENS:
	.byte 0,0
	.dbsym s SENS _SENS i
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_OFF:
	.byte 0,0
	.dbsym s OFF _OFF I
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_C6_p24_x3:
	.byte 0,0
	.dbsym s C6_p24_x3 _C6_p24_x3 i
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_C6_p24_x11:
	.byte 0,0
	.dbsym s C6_p24_x11 _C6_p24_x11 i
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_C6_p50:
	.byte 0,0
	.dbsym s C6_p50 _C6_p50 i
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_UT1:
	.byte 0,0
	.dbsym s UT1 _UT1 i
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_C6:
	.byte 0,0
	.dbsym s C6 _C6 i
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_C5_x8:
	.byte 0,0
	.dbsym s C5_x8 _C5_x8 i
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_C4_m512:
	.byte 0,0
	.dbsym s C4_m512 _C4_m512 I
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_C3:
	.byte 0,0
	.dbsym s C3 _C3 i
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_C2_x4:
	.byte 0,0
	.dbsym s C2_x4 _C2_x4 i
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_C1:
	.byte 0,0
	.dbsym s C1 _C1 i
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_Countdown_1ms::
	.byte 0,0
	.dbsym e Countdown_1ms _Countdown_1ms i
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_FSM::
	.byte 0
	.dbsym e FSM _FSM c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_Report::
	.byte 0,0,0,0,0,0
	.dbsym e Report _Report X
