	cpu LMM
	.module usbsleeptimer.c
	.area text(rom, con, rel)
	.dbfile ./usbsleeptimer.c
	.dbfunc e SleepTimer_Start _SleepTimer_Start fV
_SleepTimer_Start::
	.dbline -1
	.dbline 28
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:   UsbSleepTimer.c
; //  Version: 1.0, 2006/10/15
; //  Generated by Andy Kiser
; //
; //  DESCRIPTION:  Detect USB inactivity and set "GotoSleep" Flag accordingly
; //-----------------------------------------------------------------------------
; // Originally authored by Toradex AG. This work is now available under the terms and conditions
; // of the Creative Commons License 'Attribution CC BY', details of which can be found here:
; // http://creativecommons.org/licenses/by/3.0/
; //*****************************************************************************
; //*****************************************************************************
; #include <m8c.h>        // part specific constants and macros
; #include "PSoCAPI.h"    // PSoC API definitions for all User Modules
; 
; #define SUSPEND_TIMEOUT 2
; BYTE SleepTimerCounts;
; 
; BOOL	GotoSleep;
; 
; //-----------------------------------------------------------------------------
; // this function must be called AFTER USB has become active
; // otherwise USB idle state would be detected and after 4ms the 
; // device would go into suspend mode
; //-----------------------------------------------------------------------------
; void SleepTimer_Start()
; {	
	.dbline 29
;     OSC_CR0 = (OSC_CR0 & ~OSC_CR0_SLEEP) | OSC_CR0_SLEEP_512Hz;	// 1.95ms interrupt interval
	or F,0x10  ; iopage = 1
	and REG[0xe0],-25
	and F,0xEF ; iopage = 0
	.dbline 32
; 	
; 	// enable SleeptTimer interrupt
; 	M8C_EnableIntMask( INT_MSK0, INT_MSK0_SLEEP );
	or REG[0xe0],64
	.dbline 34
; 	// reset timeout
; 	SleepTimerCounts = SUSPEND_TIMEOUT;	
	mov REG[0xd0],>_SleepTimerCounts
	mov [_SleepTimerCounts],2
	.dbline 36
; 	// initialize Flag
; 	GotoSleep = FALSE;
	mov REG[0xd0],>_GotoSleep
	mov [_GotoSleep],0
	.dbline -2
	.dbline 37
; }
L2:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e SleepTimer_ISR _SleepTimer_ISR fV
_SleepTimer_ISR::
	.dbline -1
	or F,-64
	push A
	mov A,REG[0xd0]
	push A
	mov A,REG[0xd3]
	push A
	mov A,REG[0xd4]
	push A
	mov A,REG[0xd5]
	push A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	mov A,[__r8]
	push A
	mov A,[__r9]
	push A
	mov A,[__r10]
	push A
	mov A,[__r11]
	push A
	mov A,[__rX]
	push A
	mov A,[__rY]
	push A
	mov A,[__rZ]
	push A
	push X
	mov X,SP
	add SP,2
	.dbline 44
; 
; //-----------------------------------------------------------------------------
; // sleep timer interrupt service routine
; //-----------------------------------------------------------------------------
; #pragma interrupt_handler SleepTimer_ISR
; void SleepTimer_ISR ()
; {
	.dbline 45
; 	if ( USB_bCheckActivity() )
	push X
	xcall _USB_bCheckActivity
	pop X
	cmp A,0
	jz L4
	.dbline 46
; 		SleepTimerCounts = SUSPEND_TIMEOUT;
	mov REG[0xd0],>_SleepTimerCounts
	mov [_SleepTimerCounts],2
	xjmp L5
L4:
	.dbline 48
; 	else 
; 		if (SleepTimerCounts>0) 
	mov REG[0xd0],>_SleepTimerCounts
	mov A,0
	cmp A,[_SleepTimerCounts]
	jnc L6
X0:
	.dbline 49
; 			SleepTimerCounts--;
	mov REG[0xd0],>_SleepTimerCounts
	dec [_SleepTimerCounts]
L6:
L5:
	.dbline 51
; 	
; 	GotoSleep = (SleepTimerCounts == 0);
	mov REG[0xd0],>_SleepTimerCounts
	cmp [_SleepTimerCounts],0
	jnz L9
	mov [X+1],1
	mov [X+0],0
	xjmp L10
L9:
	mov [X+1],0
	mov [X+0],0
L10:
	mov A,[X+1]
	mov REG[0xd0],>_GotoSleep
	mov [_GotoSleep],A
	.dbline 55
; 
; 	// clear SleepTimer interrupt flag
; //	M8C_ClearIntFlag(INT_CLR0, INT_MSK0_SLEEP); 
; 	INT_CLR0 = ((BYTE)~INT_MSK0_SLEEP);
	mov REG[0xda],-65
	.dbline -2
	.dbline 56
; }
L3:
	add SP,-2
	pop X
	mov REG[0xD0],>__r0
	pop A
	mov [__rZ],A
	pop A
	mov [__rY],A
	pop A
	mov [__rX],A
	pop A
	mov [__r11],A
	pop A
	mov [__r10],A
	pop A
	mov [__r9],A
	pop A
	mov [__r8],A
	pop A
	mov [__r7],A
	pop A
	mov [__r6],A
	pop A
	mov [__r5],A
	pop A
	mov [__r4],A
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	pop A
	mov REG[213],A
	pop A
	mov REG[212],A
	pop A
	mov REG[211],A
	pop A
	mov REG[208],A
	pop A
	.dbline 0 ; func end
	reti
	.dbend
	.area data(ram, con, rel)
	.dbfile ./usbsleeptimer.c
_GotoSleep::
	.byte 0
	.dbsym e GotoSleep _GotoSleep c
	.area data(ram, con, rel)
	.dbfile ./usbsleeptimer.c
_SleepTimerCounts::
	.byte 0
	.dbsym e SleepTimerCounts _SleepTimerCounts c
